function demo(action)
% DEMO   G.729A CS-ACELP Speech Codec
%   18-796 Multimedia Coding Project Midterm Demo  
%   Graphical representation of different signals at 
%     the pre-processing and the LP analysis stages

global top;
global bottom;
global left;
global in;
global out;
global s;
global s_h;
global r;
global r_h;
global v;
global v_h;
global c;
global c_h;
global u;
global u_h;
global w;
global X;
global Y;
global Z;
global num_frame;

play= 1;
stop=-1;

if nargin<1,
   action='initialize';
end;

if strcmp(action,'initialize'),
   oldFigNumber=watchon;
   
   [in,s,r,v,c,u,w,out,s_h,r_h,v_h,c_h,u_h] = read_data;
   [X,Y,Z] = read_sound;
	num_frame = length(w)/10;
   
   labelList_fixed=strcat(' no graph |',' Original speech signal|',...
						   ' Encoder: Preprocessed signal s[n]|',...
                     ' Encoder: LP residual signal r[n]|',...
   						' Encoder: Adaptive code vector v[n]|',...
   						' Encoder: Fixed code vector c[n]|',...
                     ' Encoder: Excitation signal u[n]|',...
     						' Line Spectral Frequencies w|',...
                     ' Decoder: LP residual signal r_h[n]|',...
   						' Decoder: Adaptive code vector v_h[n]|',...
   						' Decoder: Fixed code vector c_h[n]|',...
                     ' Decoder: Excitation signal u_h[n]|',...
						   ' Decoder: Signal before postprocessing s_h[n]|',...
   						' Reconstructed speech signal');
   
   cmdList_fixed=strvcat(' ',' plot(0:79,in(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Original speech signal'');',...
                    ' plot(0:79,s(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Encoder: Preprocessed signal s[n]'');',...
                    ' plot(0:79,r(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Encoder: LP residual signal r[n]'');',...
                    ' plot(0:79,v(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Encoder: Adaptive code vector v[n]'');',...
                    ' plot(0:79,c(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Encoder: Fixed code vector c[n]'');',...
                    ' plot(0:79,u(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Encoder: Excitation signal u[n]'');',...
 					 	  ' index=1:10;polar(0,1.2,''k'');hold on;polar([w((frame_no-1)*10+index);2*pi-w((frame_no-1)*10+index)],ones(20,1),''o'');title(''Line Spectral Frequencies'');hold off;',...
                    ' plot(0:79,r_h(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Decoder: LP residual signal r-hat[n]'');',...
                    ' plot(0:79,v_h(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Decoder: Adaptive code vector v-hat[n]'');',...
                    ' plot(0:79,c_h(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Decoder: Fixed code vector c-hat[n]'');',...
                    ' plot(0:79,u_h(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Decoder: Excitation signal u-hat[n]'');',...
                    ' plot(0:79,s_h(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Decoder: Signal before postprocessing s-hat[n]'');',...
                    ' plot(0:79,out(80*(frame_no-1)+1:80*(frame_no-1)+80));title(''Reconstructed speech signal'');'...
                    );

   figNumber=figure( ...
      'Name','G.729A CS-ACELP Speech Codec Demo', ...
      'Color', [.8 .8 .8], ...
      'NumberTitle','off', ...
      'Color', [0.8 0.8 0.8], ...
      'DoubleBuffer', 'on', ...
      'Visible','off');
   
%      'Position',[0.05 0.10 0.75 0.87], ...   
   
%   axes( ...
%      'Units','normalized', ...
%      'Color', [.8 .8 .8], ...
%      'Position',[0.01 0.10 0.5 0.87], ...   
%      'Visible','off');
   
%   axis([0 1 0 1]);
   
   %===================================
   % Information for all buttons
   labelColor=[0.8 0.8 0.8];
   top=0.95;
   bottom=0.05;
   
   yInitLabelPos=0.90;
   left=0.67;
   labelWid=0.2;
   labelHt=0.05;
   btnWid=0.33;
   btnHt=0.05;
   % Spacing between the label and the button for the same command
   btnOffset=0.003;
   % Spacing between the button and the next command's label
   spacing=0.05;
   %====================================
   % The CONSOLE frame
   frmBorder=0.02;
   yPos=0.05-frmBorder;
   frmPos=[left-frmBorder yPos btnWid+2*frmBorder 0.9+2*frmBorder];
   h=uicontrol( ...
      'Style','frame', ...
      'Units','normalized', ...
      'Position',frmPos, ...
      'BackgroundColor',[0.50 0.50 0.50]);
   %====================================
   
   %====================================
    % The frame number command popup button
    btnNumber=1;
    yLabelPos=top-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Frame number';
    strtemp='1';   
    for i=2:num_frame,
       strtemp = strcat(strtemp, '|', int2str(i));
    end    
    labelList=strtemp;
    
    strtemp='frame_no = 1';   
    for i=2:num_frame,
       strtemp = strvcat(strtemp, 'frame_no = ', int2str(i));
    end    
    cmdList=strtemp;
    
    callbackStr='ourdemo frame';
    
    % Generic label information
    labelPos=[left yLabelPos-labelHt labelWid labelHt];
    uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',labelColor, ...
        'HorizontalAlignment','left', ...
        'String',labelStr);

    % Generic popup button information
    btnPos=[left yLabelPos-labelHt-btnHt-btnOffset btnWid btnHt];
    hndl1=uicontrol( ...
        'Style','popup', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',labelList, ...
        'Callback',callbackStr, ...
        'UserData',cmdList);
     
    %====================================
    % The top graph command popup button
    btnNumber=2;
    yLabelPos=top-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Top Graph';                                                   
    callbackStr='ourdemo Top';
    
    % Generic label information
    labelPos=[left yLabelPos-labelHt labelWid labelHt];
    uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',labelColor, ...
        'HorizontalAlignment','left', ...
        'String',labelStr);

    % Generic popup button information
    btnPos=[left yLabelPos-labelHt-btnHt-btnOffset btnWid btnHt];
    hndl2=uicontrol( ...
        'Style','popup', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',labelList_fixed, ...
        'Callback',callbackStr, ...
        'UserData',cmdList_fixed);
   
    %====================================
    % The bottom graph command popup button
    btnNumber=3;
    yLabelPos=top-(btnNumber-1)*(btnHt+labelHt+spacing);
    labelStr=' Bottom Graph';                   
    callbackStr='ourdemo Bottom';
    
    % Generic label information
    labelPos=[left yLabelPos-labelHt labelWid labelHt];
    uicontrol( ...
        'Style','text', ...
        'Units','normalized', ...
        'Position',labelPos, ...
        'BackgroundColor',labelColor, ...
        'HorizontalAlignment','left', ...
        'String',labelStr);

    % Generic popup button information
    btnPos=[left yLabelPos-labelHt-btnHt-btnOffset btnWid btnHt];
    hndl3=uicontrol( ...
        'Style','popup', ...
        'Units','normalized', ...
        'Position',btnPos, ...
        'String',labelList_fixed, ...
        'Callback',callbackStr, ...
        'UserData',cmdList_fixed);

    %====================================
    % The PLAY ORIGINAL SOUND button
    uicontrol( ...
        'Style','push', ...
        'Units','normalized', ...
        'Position',[left bottom+btnHt+3.5*spacing btnWid btnHt], ...
        'String','Play Original Sound', ...
        'Callback','ourdemo(''Original'')');
     
    %====================================
    % The PLAY RECONSTRUCTED SOUND button
    uicontrol( ...
        'Style','push', ...
        'Units','normalized', ...
        'Position',[left bottom+btnHt+2*spacing btnWid btnHt], ...
        'String','Play Reconstructed Sound', ...
        'Callback','ourdemo(''Reconstructed'')');
    
    %====================================
    % The CLOSE button
    uicontrol( ...
        'Style','push', ...
        'Units','normalized', ...
        'Position',[left bottom btnWid btnHt], ...
        'String','Close', ...
        'Callback','close(gcf)');
   
   % Uncover the figure
   hndlList=[hndl1 hndl2 hndl3];
   passPrmt.handle=hndlList;
   passPrmt.cmdList=cmdList_fixed;
   set(figNumber,'Visible','on', ...
      'UserData',passPrmt);
   watchoff(oldFigNumber);
   figure(figNumber);
elseif strcmp(action,'Bottom'),
   [hndl2, hndl3, cmdList, frame_no] = get_parameter(gcf);
   cmd2=get(hndl3,'Value');
   if (cmd2 ~= 1)
	   h2 = subplot('position',[0.04 0.04 left-0.07 top/2-0.07]);
   	cmdStr2 = cmdList(cmd2,:);
	   eval(cmdStr2);
   else
		h2=subplot('position',[0.04 0.04 left-0.07 top/2-0.07]);
      clear_fig(h2);
   end
elseif strcmp(action,'Top'),
   [hndl2, hndl3, cmdList, frame_no] = get_parameter(gcf);
   cmd1=get(hndl2,'Value');
	if (cmd1 ~= 1)
      h1 = subplot('position',[0.04 0.54 left-0.07 top/2-0.07]);
	   cmdStr1 = cmdList(cmd1,:);
      eval(cmdStr1);
   else
      h1 = subplot('position',[0.04 0.54 left-0.07 top/2-0.07]);
      clear_fig(h1);
   end
elseif strcmp(action,'frame'),
   [hndl2, hndl3, cmdList, frame_no] = get_parameter(gcf);
   cmd2=get(hndl3,'Value');
   if (cmd2 ~= 1)
	   subplot('position',[0.04 0.04 left-0.07 top/2-0.07]);
	   cmdStr2 = cmdList(cmd2,:);
	   eval(cmdStr2);
   else
      h2 = subplot('position',[0.04 0.04 left-0.07 top-0.07]);
      clear_fig(h2);
   end   
   cmd1=get(hndl2,'Value');
   if (cmd1 ~= 1)
	   subplot('position',[0.04 0.54 left-0.07 top/2-0.07]);
	   cmdStr1 = cmdList(cmd1,:);
	   eval(cmdStr1);
   else
      h1 = subplot('position',[0.04 0.04 left-0.07 top-0.07]); 
      clear_fig(h1);
   end   
elseif strcmp(action,'Original'),
   sound(X,8000);
elseif strcmp(action,'Reconstructed');
   sound(Y,8000);
end;


% A function to get the parameters 
function [hndl2, hndl3, cmdList, frame_no] = get_parameter(figNumber)
   passPrmt=get(figNumber, 'UserData');
   hndlList=passPrmt.handle;  
   hndl1 = hndlList(1);
   hndl2 = hndlList(2);
   hndl3 = hndlList(3);   
   cmdList=passPrmt.cmdList;
   frame_no=get(hndl1,'Value');
   
   
% A function to clear a graph
function clear_fig(h)
   hold off;
	plot(1,1);
	reset(h);
   axis off;     
   